; 
    include \masm32\include\masm32rt.inc
    include \masm32\include\debug.inc

    includelib \masm32\lib\debug.lib


; 

comment * -----------------------------------------------------
                     Build this console app with
                  "MAKEIT.BAT" on the PROJECT menu.
        ----------------------------------------------------- *

comment *

This program searches the headers and builds macros from the virtual functions
inbeded into c header files.

It makes a new file with the same name but with Macro preceeding it
and inc for extension. It will work on files that use the stdmethod for
calls. Files may need to be edited some to process. Some pointers are buried
on the var and some vars are missing. 

Example : CONST<space> needs to be changed to CONST_ 

Example: D3D9.h makes a new file called D3D9_MACRO.inc.

Start program. at prompt enter the header file name.

A lot of the program is text formatting. The output can not be read by assembler
until you open it with wordpad and save as a text file. Needs a llittle work
yet but is a nice little tool to help make assembly programming easier.

This is a free program By DEM.

Copy it give it away or throw it away but never sell it!

; *

    filemanager proto
    buildmacros proto
    scan_it proto
    get_line proto
    Do_Header proto
    Do_Comment proto
    Do_Macro proto
    update_mtext proto
    
    .data?
      value dd ?

    .data

    mbuffer STRUCT
        paper byte 512 dup(0)
        curcount dword 0
    mbuffer ENDS
    
    MacroNames STRUCT
        m0 byte "sproc",0
        m1 byte "mcall",0
        m2 byte "const",0
        m3 byte "adptr",0
        m4 byte "ppptr",0
        m5 byte "poter",0
        m6 byte "stnct",0
    MacroNames ends

    Iface STRUCT
        CurrentIndex dword 0
        Nargs dword 0
        iName byte 255 dup (0)
        Function byte 255 dup (0)
        HasReturn dword 0
    Iface ends

    file struct
        filename byte 255 dup(0)
        indexcounter dword 0    ;index
        location dword 0        ;pointer location
        Linenumber dword 0
        filesize dword 0        ;filesize
        handle dword 0          ;handle of the file
        bw  dword 0             ;bytes written to the file
        br  dword 0             ;bytes read from the file
    file ends

    infile file <>
    outfile file <>
    Interface Iface <>
    
    inbuffer  byte 512 dup(0)      ;read the line into this buffer
    outbuffer byte 512 dup(0)      ;write a new line out
    convbuf   byte 100
    mheader    mbuffer <>
    mcomments    mbuffer <>
    mtext      mbuffer <>
    macbuf     byte 255 dup(0)
    
    crlf byte 10,13,0
    declinterface byte "DECLARE_INTERFACE_(",0  ;What we want to find
    stdm byte "STDMETHOD",0         ;need to decipher this line to make the macro
    THIS_Interface byte "THIS",0
    Retvalue byte " <-- Returns a value --> ",0
    

    macr          MacroNames <>
    mcro          BYTE     "MACRO",0
    requ          BYTE     ":REQ",0
    ending        BYTE     10,13,9,"ENDM",10,13,0
    
    numargs dword ?

    endname byte "_MACRO.INC",0

    adptr_names byte "HWND ","something to make the string long",0,

    scrachpad byte 255 dup(0)
    macrobuffer byte 255 dup (0)

    Fileheader byte ";---------------------------------------------------",13,
                    ";              Generated macro file                 ",13,
                    ";   Making function calls easier in assembly. - DEMI",13,
                    ";---------------------------------------------------",13,13
       macro0 byte  "    sproc macro p:req",13,10,13,
                    "        mov eax,&p&",13,10,
                    "        mov dword ptr[esp],eax",13,10,
                    "        mov edx,dword ptr[eax]",13,10,13,
                    "    ENDM",13,10,13
       macro1 byte  "    mcall MACRO c:REQ, s:REQ",13,10,13,
                    "       if c EQ 0",13,10,
                    "           call dword ptr[edx]",13,10,
                    "       else",13,10,
                    "           call dword ptr[edx+c]",13,10,
                    "       endif",13,10,
                    "       sub esp,s",13,10,13,10,
                    "    ENDM",13,10,13
       macro2 byte  "    const MACRO a:REQ, c:REQ",13,
                    "        if c EQ 0",13,10,
                    "            mov dword ptr[esp],&a&",13,10,
                    "        else",13,10,
                    "            mov dword ptr[esp+c],&a&",13,10,
                    "        endif",13,10,
                    "    ENDM",13,10,13
       macro3 byte  "    adptr MACRO a:REQ, c:REQ",13,
                    "        mov eax,&a&",13,10,
                    "        stnct c",13,10,
                    "    ENDM",13,10,13
       macro4 byte  "    ppptr MACRO a:REQ, c:REQ",13,10,
                    "        mov  eax,offset &a&",13,10,
                    "        stnct c",13,10,
                    "    ENDM",13,10,13
       macro5 byte  "    poter MACRO a:REQ, c:REQ",13,10,
                    "        lea eax,[&a&]",13,10,
                    "        stnct c",13,10,
                    "    ENDM",13,10,13
       macro6 byte  "    stnct MACRO c:req",13,10,
                    "        if c EQ 0",13,10,
                    "            mov dword ptr[esp],eax",13,10,
                    "        else",13,10,
                    "            mov dword ptr[esp+c],eax",13,10,
                    "        endif",13,10,
                    "    ENDM",13,10,13,0

   lfile   dword ?

   temp dword ?

    file_read_error Byte "This file is not compatable with this version of h2macros",10,13,
                         "edit the file and remove the linefeeds.",10,13,0

    .code

start:

; 

    call main
    invoke FlushFileBuffers, outfile.handle
    invoke CloseHandle, outfile.handle
    print "All done",10,13
    inkey
    exit

; 

main proc

    cls
    print "Enter file name for processing. "
    invoke StdIn, addr infile.filename, 255
    invoke StdOut, addr crlf

        ;find and replace crlf with a zero
        ;on the infile

            xor ecx,ecx
            mov esi,offset infile.filename
        @@: inc ecx
            mov al,[esi]
            cmp ecx,128
            jae @f
            inc esi
            cmp al,13
            jne @b
        @@: mov byte ptr [esi-1],0

    invoke filesize, addr infile.filename
    
    .if eax == -1
        print "That file does not exist",10,13,0
    .else
        mov infile.filesize,eax
        invoke buildmacros
        invoke filemanager
    .endif

    ret

main endp

; 


filemanager proc

        invoke read_disk_file, addr infile.filename, 
                               addr infile.location, 
                               addr infile.filesize
        .if eax == 0
            print "error opening file"
            ret
        .endif
        
        mov eax,infile.location
        add eax,infile.filesize
        mov infile.indexcounter,eax
        invoke scan_it  
        ret
        
filemanager endp

; 

buildmacros proc


        mov esi, offset infile.filename
        mov edi, offset outfile.filename

            xor ecx,ecx
            .while ecx < 128
                mov al,[esi]
                .if al == "."
                    .break
                .else
                    mov byte ptr [edi],al
                    inc esi
                    inc edi
                .endif
                inc ecx
            .endw
            xor ecx,ecx
            mov esi, offset endname
            .while ecx <128
                mov al,[esi]
                .if al == 0
                    .break
                .else
                    mov byte ptr [edi],al
                    inc esi
                    inc edi
                .endif
                inc ecx
            .endw
            
        invoke CreateFile,addr outfile.filename,GENERIC_WRITE,NULL,NULL,
                      CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL

        .if eax == INVALID_HANDLE_VALUE
            print "error opening output file"
            ret
        .endif
        
        mov outfile.handle, eax
        invoke szLen, addr Fileheader
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr Fileheader,lfile,ADDR outfile.bw,NULL
        ret

buildmacros endp

; 

scan_it proc

; 
    look_for_interface:               ;Jump point
; 

            mov Interface.CurrentIndex,0      ;clear the index counter for this interface
            
            ;stay in this loop until either 
            ;the end of file or we find  the interface
            ;Need to find the interface first
            
            .while 1
                invoke get_line

                .if eax == -1
                  ret                   ;we reached the end of the file
                .endif                  ;don't exit the loop, return instead


                invoke InString,1,addr inbuffer,addr declinterface

                .if eax == -2
                    xor eax,eax
                .elseif eax == -1
                    xor eax,eax
                .elseif eax > 0
                    .break
                .endif
                
            .endw

            ;OK now that we found the interface
            ;let's save it and go to the next step
            
            invoke memfill, addr Interface.iName,200,0
            mov esi, offset inbuffer
            mov edi, offset Interface.iName
            add esi,eax
            add esi,19
            mov al, [esi]
            .while al != ","
                mov [edi],al
                inc esi
                inc edi
                mov al, [esi]
            .endw
            mov al,"_"
            mov [edi],al

            ;The name is built now so
            ;start looking for the STDMETHOD
; 
    look_for_std:               ;Jump point
; 


            .while 1
                invoke get_line
                .if eax == -1                ;we reached the end of the file
                  ret                        ;don't exit the loop just return
                .endif

                ;check if the interface is finished. Denoted by the };
                
                mov esi,offset inbuffer
                mov al,[esi]
                .if al == "}"
                    mov al,[esi+1]
                    
                    .if al == ";"    ;verify that this is indeed the end of the interface
                    
                        jmp interface_is_done
                    .endif
                .endif

                ;Again, stay in this loop and get the STDMETHOD.
                ;Skip the comments, linefeeds and carriage returns.
                
                invoke InString,1,addr inbuffer,addr stdm
                
                .if eax == -2
                    xor eax,eax
                .elseif eax == -1
                    xor eax,eax
                .elseif eax > 0
                    .break
                .endif
            .endw


            ;Check if this interface function returns a value or not

            invoke memfill, addr Interface.Function,200,0
            
            mov Interface.HasReturn,0
            mov esi,offset inbuffer
            .while al != "("        ;the starting def
                mov al,[esi]
                inc esi
            .endw
            dec esi
            mov al,[esi-1]

            ;The underscore denotes this interface function has a returned value
            
            .if al == "_"
                mov Interface.HasReturn,1
            .endif

            
            mov edi,offset Interface.Function
            inc esi
            inc esi
            
            ;find the end of this function name
            
            .while al != ")" 
                mov al,[esi]
                inc esi
            .endw
@@:
            ;now work backwards to find the start of the name
            dec esi
            mov al, [esi]
            .if al == "("
                jmp @f
            .elseif al == ","
                jmp @f
            .endif
            jmp @b
@@:                             ;OK save this interface name
            inc esi
            .while al != ")"
                mov al,[esi]
                .if al != " "       ;remove the spaces
                    mov [edi],al
                    inc edi
                .endif
                inc esi
            .endw
            dec edi
            mov byte ptr[edi],0
            
            ;OK now we have the interface function name we need to 
            ;start looking for THIS. THIS is always first.
            ;Repensented as (p)-> or the pointer to this interface
            
            mov Interface.Nargs,0       ;clear the arg counter here
                                        ;so the stack counts are correct

            invoke InString,1,addr inbuffer,addr THIS_Interface
            mov esi,offset inbuffer
            add esi,eax
            add esi,3
            mov al,[esi]
            cmp al,"_"                  ;if the underscore is after THIS
            jne no_args     ;There are args else THIS is the only argument

            ;now we need to get a count on the args
            ; we know one arg exists so increment the args
            
            inc Interface.Nargs
            .while al != ")"              ;this is the end of the list
                mov al,[esi]
                inc esi

        ; 
        ;Newer files are not supported yet so if we hit the end of the line
        ;we better stop execution. Need to work on getting the newer file
        ;structures implemented. Right now we can edit them by removing the
        ;carriage returns, line feeds and the damn comments.
        ; ------------------------------------

                .if al == 0 
                    ;we hit the end of the line and no ending ")"
                    print file_read_error
                    print addr inbuffer
                    print "----- error here"
                    print addr crlf
                    inkey
                    
                    ;exit the app cause it would really screw up things
                    
                    invoke FlushFileBuffers, outfile.handle
                    invoke CloseHandle, outfile.handle
                    exit
                    
                .endif
                .if al == ","             ;argments seperator
                    inc Interface.Nargs   ;we have another arg
                .endif
            .endw
             push Interface.Nargs
             pop numargs
            invoke memfill,addr macbuf,200,0

            invoke Do_Header    
            invoke Do_Comment       
            Invoke Do_Macro

            ; 
            ;  Now that we have the arg count we need to find out 
            ;  what args we are working with. The first argument 
            ;  though is special since it is still buried in the
            ;  entire string so we have to extract the list
            ; 

            ;save the args in scrachpad
            invoke memfill,addr scrachpad,248,0
            push edi
            mov edi,offset scrachpad
            dec esi
            .while 1
                mov al,[esi]
                .if al =="("
                    .break
                .endif
                dec esi                
            .endw
            inc esi
            .while 1
                mov al,[esi]
                .if al == ")"
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
            .endw
            pop edi


            ;clear out inbuffer and move them back
            ;this gets the arg list
            
            invoke memfill,addr inbuffer, 240,0
            mov ecx, len(addr scrachpad)
            mov edi, offset inbuffer
            mov esi, offset scrachpad
            push ecx
            rep movsb
            pop ecx
            mov esi,offset inbuffer
            add esi,ecx
            .while al != ","
                mov al,[esi]
                .if al ==" "
                    mov al,[esi-1]
                    .if al == "_"
                        dec esi
                        .break
                    .endif
                .endif
                dec esi
            .endw
            add esi,2  ;align esi to point to first character of the arg

            ;Now exrtact the first arg since
            ;esi pointes to the first arg
            
            mov edi,offset scrachpad
            .repeat
                mov al,[esi]
                mov [edi],al
                inc esi
                inc edi
            .until al == 0

            ;last is trim it off to just the type
            xor eax,eax
            mov esi,offset scrachpad
            .while al != " "
                mov al,[esi]
                inc esi
            .endw
            mov al,0
            mov [esi],al

           

; 
    Testit:                 ;Jump point
; 
            invoke update_mtext

            mov eax, len(addr scrachpad)
            .if eax == 0
                print "error in file at line "
                mov eax,infile.Linenumber
                invoke dwtoa, eax, addr convbuf
                print addr convbuf
                print " missing or missread arg",10,13
                print addr crlf
                inkey
            .endif

            ;Becasue we have to invoke through the register we have to build the
            ;call list backwards and the macro forwards. So we start at the high
            ;end of the buffer and build it. But we put the strings out forwards.

            pushad
            mov edi,offset macbuf   ;get the buffer for the call list
            mov esi,offset requ
            xor eax,eax
            mov ecx,eax
            mov edx,eax
            mov cl,"a"              ;Starting with "a" we can add up to 20 args
            mov eax,numargs         ;Get the number of args for this function
            dec eax                 ;remove one arg since it is THIS
            add cl,al               ;add the arg count to the character
            mov dl,al
            shl edx,3               ;mul by 8 to get the current position
            add edi,edx             
            mov al,","              ;then fill the buffer up
            mov [edi],al
            inc edi
            mov al," "
            mov [edi],al
            inc edi
            mov [edi],cl
            inc edi
            mov ecx,4
            rep movsb
            mov al," "
            mov [edi],al
            popad
            
; 
; Here we process all args. The args are in the scrachpad. The list is in the inbuffer
; 

            ;Starting at the end of the buffer and finding the previous
            ;arg then eliminate it. Have to loop this so we need to
            ;make it universal.

            dec numargs
            .if numargs == 0
                jmp finished
            .elseif numargs < 0  ;Should be a catch all
                jmp finished
            .endif

            ;moved the list to scrachpad
            xor ecx,ecx
            invoke memfill,addr scrachpad,240,0
            mov esi,offset inbuffer
            mov edi,offset scrachpad
            .while 1
                mov al,[esi]
                mov [edi],al
                inc esi
                inc edi
                .if al == 0
                    .break
                .endif
            .endw

            
            ; find the next arg and extract the list
            ; eliminating the first arg
            
            invoke memfill,addr inbuffer,240,0
            mov esi,offset scrachpad
            mov edi,offset inbuffer
            mov ecx, len(addr scrachpad)
            add esi,ecx
            xor eax,eax
            .while al != ","
                mov al,[esi]
                .if al ==" "
                    mov al,[esi-1]
                    .if al == "_"    ;Catch THIS_
                        dec esi
                        .break
                    .endif
                .endif
                dec esi
            .endw
            ;Found the comma to the first arg
            ;so we zero it
            mov al,0
            mov [esi],al                

            ;now need save it back in the inbuffer
            mov esi,offset scrachpad
            mov edi,offset inbuffer
            .repeat
                mov al,[esi]
                mov [edi],al
                inc esi
                inc edi
            .until al == 0

            ;extract the top arg back into scrachpad
            

            invoke memfill,addr scrachpad,240,0
            mov edi,offset scrachpad
            mov esi,offset inbuffer
            mov ecx, len(addr inbuffer)
            add esi,ecx
            xor eax,eax
            .while al != ","
                mov al,[esi]
                .if al ==" "
                    mov al,[esi-1]
                    .if al == "_"    ;Catch THIS_
                        dec esi
                        .break
                    .endif
                .endif
                dec esi
            .endw
            add esi,2
            .repeat
                mov al,[esi]
                mov [edi],al
                inc esi
                inc edi
            .until al == 0
            
            ;last is trim it off to just the type
            xor eax,eax
            mov esi,offset scrachpad
            .while al != " "
                mov al,[esi]
                inc esi
            .endw
            mov al,0
            mov [esi],al

            jmp Testit


; 
; ------------------------------------
;                       SHOULD NEVER GET HERE
stophere:
;Should not ever end up here
;catch all
print "You should never get here!",10,13
inkey
exit
; 
; 

; 
    no_args:            ;Jump point
; 

            pushad
            invoke Do_Header 
            invoke Do_Comment       
            Invoke Do_Macro
            invoke memfill,addr macbuf,200,0
            ;here we know that the args are done but we need to set up the output lines
            mov edi, offset mtext.paper
            mov eax,mtext.curcount
            add edi,eax
            mov al,13
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,10
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,9
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov esi,offset macr.m1
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al," "
            mov [edi],al
            inc edi
            inc mtext.curcount
            invoke memfill,addr macrobuffer,200,0
            mov eax, Interface.CurrentIndex
            shl eax,2
            invoke dwtoa, eax, addr macrobuffer
            mov esi,offset macrobuffer
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al,","
            mov [edi],al
            inc edi
            inc mtext.curcount
            invoke memfill,addr macrobuffer,200,0
            xor eax,eax
            mov eax,Interface.Nargs
            shl eax,2
            .if eax == 0
                mov eax,4
            .endif
            invoke dwtoa, eax, addr macrobuffer
            mov esi,offset macrobuffer
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            popad


; 
;       
; 
        mov edi,offset mheader.paper
        mov eax,mheader.curcount
        add edi,eax
        mov al,13
        mov [edi],al
        mov al,10
        mov [edi+1],al
        mov edi,offset mcomments.paper
        mov eax,mcomments.curcount
        add edi,eax
        mov al,13
        mov [edi],al
        mov al,10
        mov [edi+1],al
        mov edi,offset mtext.paper
        mov eax,mtext.curcount
        add edi,eax
        mov al,13
        mov [edi],al
        mov al,10
        mov [edi+1],al
        mov esi,offset ending
        .while 1
            mov al,[esi]
            .if al == 0
                .break
            .endif
            mov [edi],al
            inc esi
            inc edi
        .endw
        
        invoke szLen, addr mheader.paper
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr mheader.paper,lfile,ADDR outfile.bw,NULL
        
        invoke szLen, addr mcomments.paper
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr mcomments.paper,lfile,ADDR outfile.bw,NULL
        
        invoke szLen, addr mtext.paper
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr mtext.paper,lfile,ADDR outfile.bw,NULL

            print addr mheader.paper
            print " ",10,13
            print addr mcomments.paper
            print " ",10,13
            print addr mtext.paper
            print " ",10,13
            inc Interface.CurrentIndex      ;now we start the index counter after first pass
            jmp look_for_std

;Was letting No_Args fall through but the changes will mess it up so it has its own
;jump out and will be different than finished jump point

; 
    finished:            ;Jump point
; 

;basicly just formatting

            mov esi,offset macbuf
            mov edi,offset mheader.paper
            mov eax,mheader.curcount
            add edi,eax
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc edi
                inc esi
                inc mheader.curcount
            .endw

            mov edi, offset mtext.paper
            mov eax,mtext.curcount
            add edi,eax
            mov al,13
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,10
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,9
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov esi,offset macr.m1
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al," "
            mov [edi],al
            inc edi
            inc mtext.curcount
            invoke memfill,addr macrobuffer,200,0
            mov eax, Interface.CurrentIndex
            shl eax,2
            invoke dwtoa, eax, addr macrobuffer
            mov esi,offset macrobuffer
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al,","
            mov [edi],al
            inc edi
            inc mtext.curcount
            invoke memfill,addr macrobuffer,200,0
            xor eax,eax
            mov eax,Interface.Nargs
            shl eax,2
            add eax,4
            .if eax == 0
                mov eax,4
            .endif
            invoke dwtoa, eax, addr macrobuffer
            mov esi,offset macrobuffer
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw

; 
; This is the dump point to the file for this -- FIXME
; 
        mov edi,offset mheader.paper
        mov eax,mheader.curcount
        add edi,eax
        mov al,13
        mov [edi],al
        mov al,10
        mov [edi+1],al
        mov edi,offset mcomments.paper
        mov eax,mcomments.curcount
        add edi,eax
        mov al,13
        mov [edi],al
        mov al,10
        mov [edi+1],al
        mov edi,offset mtext.paper
        mov eax,mtext.curcount
        add edi,eax
        mov al,13
        mov [edi],al
        mov al,10
        mov [edi+1],al
        mov esi,offset ending
        .while 1
            mov al,[esi]
            .if al == 0
                .break
            .endif
            mov [edi],al
            inc esi
            inc edi
        .endw
        
        invoke szLen, addr mheader.paper
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr mheader.paper,lfile,ADDR outfile.bw,NULL
        
        invoke szLen, addr mcomments.paper
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr mcomments.paper,lfile,ADDR outfile.bw,NULL
        
        invoke szLen, addr mtext.paper
        mov lfile,eax
        invoke WriteFile,outfile.handle,addr mtext.paper,lfile,ADDR outfile.bw,NULL

            print addr mheader.paper
            print " ",10,13
            print addr mcomments.paper
            print " ",10,13
            print addr mtext.paper
            print " ",10,13
            inc Interface.CurrentIndex      ;now we start the index counter after first pass
            jmp look_for_std
; 
    interface_is_done:            ;Jump point
; 

            jmp look_for_interface          
            ret

scan_it endp

; 

get_line proc

            invoke memfill, addr inbuffer,200,0
            xor ecx,ecx
            xor eax,eax
            mov infile.br,eax
            invoke readline, infile.location, addr inbuffer, infile.br
            inc infile.Linenumber
            inc ecx
            inc ecx
            mov eax,infile.location
            add eax,ecx
            mov infile.location,eax
            mov edx,infile.indexcounter
            .if eax > edx
                mov eax, -1
                ret
            .endif            
            mov eax,0
            ret
            
get_line endp


; 

Do_Header proc

            pushad
            invoke memfill, addr mheader.paper, 200,0
            mov mheader.curcount,0
            mov esi, offset Interface.iName

            mov edi, offset mheader.paper
            mov al," "
            xor ecx,ecx
            .while ecx < 3
                mov [edi],al
                inc ecx
                inc edi
                inc mheader.curcount
            .endw
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mheader.curcount
            .endw

            mov esi, offset Interface.Function 
            
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mheader.curcount
            .endw
            mov al," "
            mov [edi],al
            inc edi
            inc mheader.curcount
            mov esi,offset mcro
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mheader.curcount
            .endw
        
            mov al," "
            mov [edi],al
            inc edi
            inc mheader.curcount
            mov al,"p"
            mov [edi],al
            inc edi
            inc mheader.curcount
            mov esi,offset requ
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mheader.curcount
            .endw
            popad
            ret
        
Do_Header endp

; 


Do_Comment proc

            pushad
            mov mcomments.curcount,0
            invoke memfill, addr mcomments.paper,200,0 
            mov edi, offset mcomments.paper
            mov mcomments.curcount,0
            mov al," "
            xor ecx,ecx
            .while ecx < 3
                mov [edi],al
                inc ecx
                inc edi
                inc mcomments.curcount
            .endw
        
            mov al,";"
            mov [edi],al
            inc edi
            inc mcomments.curcount
    
            .if Interface.HasReturn == 1
                push esi
                mov esi, offset Retvalue
                .while 1
                    mov al,[esi]
                    .if al == 0
                        .break
                    .endif
                    mov [edi],al
                    inc esi
                    inc edi
                    inc mcomments.curcount
                .endw
                pop esi
            .endif        
    
            mov esi,offset inbuffer
            .while al != "("
                mov al,[esi]
                inc esi
                inc mcomments.curcount
            .endw
            dec esi
            .while al != 0
                mov al,[esi]
                mov [edi],al
                inc edi
                inc esi
                inc mcomments.curcount
            .endw 
        popad
        ret
        
Do_Comment endp

; 


Do_Macro proc

            pushad
            invoke memfill,addr mtext.paper,200,0
            mov mtext.curcount,0
            mov edi,offset mtext.paper

            mov al,13
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,10
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,9
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov esi,offset macr.m0
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al, " "
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"&"
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"p"
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"&"
            mov [edi],al
            inc edi
            inc mtext.curcount
            popad
            ret
            
Do_Macro endp


; 


update_mtext proc

            mov esi, offset scrachpad
            .while 1
                mov al,[esi]
                .if al == "*"
                    mov al,[esi+1]
                    .if al == "*"
                        jmp pointerpointer
                    .endif
                    jmp a_single_pointer
                .endif
                .if al == 0
                     .break
                .endif
                inc esi
           .endw

        
;fall through to the constant the label is not used but makes it look structured
; 
    a_constant:            ;Jump point
; 

            ;grab the arg type here
            pushad

            ;currently only HWND is known to be a true address. Need to edit
            ;in the ones that we come across.

            invoke InString, 1,addr adptr_names, addr scrachpad
            .if eax == -2
                xor eax,eax
            .elseif eax == -1
                xor eax,eax
            .elseif eax > 0
                mov edi,offset mtext.paper
                add edi,mtext.curcount
                mov al,13
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,10
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,9
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov esi,offset macr.m3
                .while 1
                    mov al,[esi]
                    .if al == 0
                        .break
                    .endif
                    mov [edi],al
                    inc esi
                    inc edi
                    inc mtext.curcount
                .endw
                mov al, " "
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,"&"
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov cl,96
                mov eax,numargs
                add al,cl
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,"&"
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,","
                mov [edi],al
                inc edi
                inc mtext.curcount
                invoke memfill,addr macrobuffer,200,0
                xor eax,eax
                mov eax,numargs
                shl eax,2
                .if eax == 0
                    mov eax,4
                .endif
                invoke dwtoa, eax, addr macrobuffer
                mov esi,offset macrobuffer
                .while 1
                    mov al,[esi]
                    .if al == 0
                        .break
                    .endif
                    mov [edi],al
                    inc esi
                    inc edi
                    inc mtext.curcount
                .endw
            .elseif al == 0
                mov edi,offset mtext.paper
                add edi,mtext.curcount
                mov al,13
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,10
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,9
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov esi,offset macr.m2
                .while 1
                    mov al,[esi]
                    .if al == 0
                        .break
                    .endif
                    mov [edi],al
                    inc esi
                    inc edi
                    inc mtext.curcount
                .endw
                mov al, " "
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,"&"
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov cl,96
                mov eax,numargs
                add al,cl
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,"&"
                mov [edi],al
                inc edi
                inc mtext.curcount
                mov al,","
                mov [edi],al
                inc edi
                inc mtext.curcount
                invoke memfill,addr macrobuffer,200,0
                xor eax,eax
                mov eax,numargs
                shl eax,2
                .if eax == 0
                    mov eax,4
                .endif
                invoke dwtoa, eax, addr macrobuffer
                mov esi,offset macrobuffer
                .while 1
                    mov al,[esi]
                    .if al == 0
                        .break
                    .endif
                    mov [edi],al
                    inc esi
                    inc edi
                    inc mtext.curcount
                .endw
            .endif
            
            popad
            ret
            
; 
    a_single_pointer:            ;Jump point
; 

            ;here we need to check if the arg is a memory dword or a true constant
            ;some of the pointers may not work so we may have to hand edit the file
            ;for a few missed directed pointers. Hopefully I get them all right.
            
            pushad
            mov edi,offset mtext.paper
            add edi,mtext.curcount
            mov al,13
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,10
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,9
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov esi,offset macr.m3
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al, " "
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"&"
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov cl,96
            mov eax,numargs
            add al,cl
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"&"
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,","
            mov [edi],al
            inc edi
            inc mtext.curcount
            invoke memfill,addr macrobuffer,200,0
            xor eax,eax
            mov eax,numargs
            shl eax,2
            .if eax == 0
                mov eax,4
            .endif
            invoke dwtoa, eax, addr macrobuffer
            mov esi,offset macrobuffer
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
        
            popad
            ret
            
; 
    pointerpointer:            ;Jump point
; 

            pushad
            mov edi,offset mtext.paper
            add edi,mtext.curcount
            mov al,13
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,10
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,9
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov esi,offset macr.m4
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            mov al, " "
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"&"
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov cl,96
            mov eax,numargs
            add al,cl
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,"&"
            mov [edi],al
            inc edi
            inc mtext.curcount
            mov al,","
            mov [edi],al
            inc edi
            inc mtext.curcount
            invoke memfill,addr macrobuffer,200,0
            xor eax,eax
            mov eax,numargs
            shl eax,2
            .if eax == 0
                mov eax,4
            .endif
            invoke dwtoa, eax, addr macrobuffer
            mov esi,offset macrobuffer
            .while 1
                mov al,[esi]
                .if al == 0
                    .break
                .endif
                mov [edi],al
                inc esi
                inc edi
                inc mtext.curcount
            .endw
            popad
            ret

update_mtext endp


end start
