; 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\msvcrt.inc
      include \masm32\macros\macros.asm
      include d3d9_macro.inc
      include d3d9.inc
      include d3dx9.inc
      include \masm32\include\debug.inc
      
;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\msvcrt.lib
      includelib \masm32\lib\d3d9.lib
      includelib \masm32\lib\d3dx9.lib
      includelib \masm32\lib\debug.lib
      
; 

        ;=================
        ; Local prototypes
        ;=================
        WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY            PROTO :DWORD,:DWORD
        Paint_Proc       PROTO :DWORD
        RegisterWinClass PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        MsgLoop          PROTO
        Main             PROTO
        InitD3D          PROTO
	  Cleanup 		 PROTO
	  Render		 PROTO
        InitGeometry     PROTO
        SetupMatrices    PROTO


      AutoScale MACRO swidth, sheight
        invoke GetPercent,sWid,swidth
        mov Wwd, eax
        invoke GetPercent,sHgt,sheight
        mov Wht, eax

        invoke TopXY,Wwd,sWid
        mov Wtx, eax

        invoke TopXY,Wht,sHgt
        mov Wty, eax
      ENDM

      DisplayMenu MACRO handl, IDnum
        invoke LoadMenu,hInstance,IDnum
        invoke SetMenu,handl,eax
      ENDM

      DisplayWindow MACRO handl, ShowStyle
        invoke ShowWindow,handl, ShowStyle
        invoke UpdateWindow,handl
      ENDM

    .data
        szDisplayName db "testing ",0
        g_pD3D       DWORD 0         ;Used to create the D3DDevice
        g_pd3dDevice DWORD 0         ;Our rendering device
        g_pVB        DWORD 0         ;Buffer to hold vertices


;A structure for our custom vertex type
        CUSTOMVERTEX STRUCT
             x REAL4      ?     ;The transformed position for the vertex
             y REAL4      ?
             z REAL4      ?
             color DWORD  ?     ;The vertex color
        CUSTOMVERTEX ENDS

;Our custom FVF, which describes our custom vertex structure
D3DFVF_CUSTOMVERTEX equ 42h
        
    ;Initialize three vertices for rendering a triangle

    Vertices CUSTOMVERTEX < -1.0f,-1.0f, 0.0f, 0ffff0000h>,
                          <1.0f,-1.0f, 0.0f, 0ff0000ffh>,
                          <0.0f, 1.0f, 0.0f, 0ffffffffh>

    D3DXVECTOR3 STRUCT
    
            x REAL4 ?
            y REAL4 ?
            z REAL4 ?
            
    D3DXVECTOR3 ends

        D3DMATRIX STRUCT
                    _11 REAL4 ?
                    _12 REAL4 ?
                    _13 REAL4 ?
                    _14 REAL4 ?
                    _21 REAL4 ?
                    _22 REAL4 ?
                    _23 REAL4 ?
                    _24 REAL4 ?
                    _31 REAL4 ?
                    _32 REAL4 ?
                    _33 REAL4 ?
                    _34 REAL4 ?
                    _41 REAL4 ?
                    _42 REAL4 ?
                    _43 REAL4 ?
                    _44 REAL4 ?
        D3DMATRIX ends

      matWorld D3DMATRIX <>
      matView  D3DMATRIX <>
      matProj  D3DMATRIX <>
      vEyePt D3DXVECTOR3 < 0.0f, 3.0f,-5.0f >
      vLookatPt D3DXVECTOR3 < 0.0f, 0.0f, 0.0f >
      vUpVec D3DXVECTOR3 < 0.0f, 1.0f, 0.0f >
      SysTime SYSTEMTIME <>

      fAngle real4 20.2
	tempa DWORD 0
	numbr REAL4 150.0
      pVertices DWORD ?
      sVertices EQU SIZEOF Vertices
      sCUSTOMVERTEX EQU SIZEOF CUSTOMVERTEX

        tempb real4 0.006283185
        tempc real4 1.0
        tempd real4 100.0
        
    .data?
        hInstance dd ?
        CommandLine dd ?
        hIcon dd ?
        hCursor dd ?
        sWid dd ?
        sHgt dd ?
        hWnd dd ?
        
;  Inserted modules 

      include Statusbr.asm

; 

